## fontforge 20201107~dfsg

=== CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

cmake_minimum_required(VERSION 3.5)

# No in source builds
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are disallowed. Create a build folder to run CMake from.")
endif()

# Update the version for each new release
project(fontforge VERSION 20201107 LANGUAGES C CXX)

# Add folder for custom cmake modules
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_SOURCE_DIR}/cmake/packages)
if(${CMAKE_VERSION} VERSION_LESS "3.15.7")
  # This could be more targeted, but keep it simple
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/backports/3.15.7)
endif()

# Include any required modules
include(BuildUtils)
include(CheckIncludeFile)
include(CPackSetup)
include(CTest)
include(GNUInstallDirs)
include(PackageUtils)
include(TargetUtils)

# Set any global defines
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED TRUE)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)
set(CMAKE_THREAD_PREFER_PTHREAD 1)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

set_default_build_type(RelWithDebInfo) # Sets CMAKE_BUILD_TYPE
set_default_rpath()
add_uninstall_target()

# Options
build_option(BUILD_SHARED_LIBS       BOOL ON  "Build libfontforge as a shared library")
build_option(ENABLE_GUI              BOOL ON  "Build FontForge with GUI support")
build_option(ENABLE_X11              BOOL OFF "Build the GUI using the X backend INSTEAD of the GDK backend" "ENABLE_GUI")

build_option(ENABLE_NATIVE_SCRIPTING BOOL ON  "Enables FontForge's native scripting support")
build_option(ENABLE_PYTHON_SCRIPTING BOOL ON  "Enables FontForge's Python scripting support")
build_option(ENABLE_PYTHON_EXTENSION AUTO ON  "Builds the Python models for use with system python")

build_option(ENABLE_LIBSPIRO         BOOL ON  "Enables libspiro support")
build_option(ENABLE_LIBUNINAMESLIST  BOOL ON  "Enables libuninameslist support")
build_option(ENABLE_LIBGIF           AUTO ON  "Enables GIF support")
build_option(ENABLE_LIBJPEG          AUTO ON  "Enables JPEG support")
build_option(ENABLE_LIBPNG           AUTO ON  "Enables PNG support")
build_option(ENABLE_LIBREADLINE      AUTO ON  "Enables Readline support")
build_option(ENABLE_LIBTIFF          AUTO ON  "Enables TIFF support")
build_option(ENABLE_WOFF2            AUTO ON  "Enables WOFF2 support")

build_option(ENABLE_DOCS             AUTO ON  "Enables building and installing documentation. Sphinx is required to build it.")
build_option(ENABLE_CODE_COVERAGE    BOOL OFF "Build with code coverage support")
build_option(ENABLE_DEBUG_RAW_POINTS BOOL OFF "Add a raw mode to the points window of the debugger")
build_option(ENABLE_FONTFORGE_EXTRAS BOOL OFF "Builds programs from the contrib directory")
build_option(ENABLE_MAINTAINER_TOOLS BOOL OFF "Build programs normally only used by FontForge maintainers and developers")
build_option(ENABLE_TILE_PATH        BOOL OFF "Enable a 'tile path' command (a variant of 'expand stroke')")
build_option(ENABLE_WRITE_PFM        BOOL OFF "Add the ability to save a PFM file without creating the associated font file")
build_option(ENABLE_SANITIZER        ENUM "none" "Enables a sanitizer. Requires support from the compiler."
                                          "none" "address" "leak" "thread" "undefined" "memory")

build_option(ENABLE_FREETYPE_DEBUGGER PATH "" "Use FreeType's internal debugger within FontForge.\
 If enabling this option, this must be set to the path of the FreeType source.\
 The version of that source must match the version that FontForge will link to.")

build_option(SPHINX_USE_VENV BOOL OFF "If building documentation and Sphinx\
 is not installed, try to install and use it from a python3 venv.")

build_option(REAL_TYPE ENUM "double" "Sets the floating point type used." "double" "float")
build_option(THEME     ENUM "tango"  "Sets the GUI theme." "tango" "2012")

if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
  list(APPEND _test_flags CFLAGS -Werror=implicit-function-declaration -Werror=int-conversion)
  if(CMAKE_GENERATOR STREQUAL "Ninja") # https://github.com/ninja-build/ninja/wiki/FAQ
    list(APPEND _test_flags BOTH -fdiagnostics-color=always)
  endif()
  set_supported_compiler_flags(FONTFORGE_DEFAULT_CFLAGS FONTFORGE_DEFAULT_CXXFLAGS ${_test_flags})
  list(APPEND FONTFORGE_EXTRA_CFLAGS -Wall -Wextra -pedantic)
  add_compile_options(
    "$<$<COMPILE_LANGUAGE:C>:${FONTFORGE_DEFAULT_CFLAGS}>"
    "$<$<COMPILE_LANGUAGE:CXX>:${FONTFORGE_DEFAULT_CXXFLAGS}>"
  )
endif()

enable_sanitizer("${ENABLE_SANITIZER}")

# Required and default dependencies
# Note: When adding a dependency, ensure it has an imported target (wherever appropriate) 
find_package(Freetype 2.3.7 REQUIRED)
find_package(Gettext REQUIRED)
find_package_with_target(Intl REQUIRED)
find_package(GLIB 2.6 REQUIRED COMPONENTS gio)
find_package(Iconv REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(MathLib REQUIRED)
find_package(ZLIB REQUIRED)

check_include_file(pthread.h HAVE_PTHREAD_H)
if(HAVE_PTHREAD_H)
  find_package(Threads)
endif()

# Requirements for options
if(ENABLE_GUI)
  if(ENABLE_X11)
    find_package(Cairo 1.6 REQUIRED)
    find_package(Pango 1.10 COMPONENTS pangocairo pangoxft REQUIRED)
    find_package(X11 REQUIRED)
  else()
    find_package(GDK3 3.10 REQUIRED)
  endif()
endif()

if(ENABLE_FREETYPE_DEBUGGER)
  if(NOT HAVE_PTHREAD_H)
    message(FATAL_ERROR "pthreads must be present to enable the FreeType debugger")
  else()
    set(FreeTypeSource_HINT ${ENABLE_FREETYPE_DEBUGGER})
    find_package(FreeTypeSource "${FREETYPE_VERSION_STRING}" EXACT REQUIRED)
  endif()
endif()

set(Python3_FIND_REGISTRY LAST)
if(BUILD_SHARED_LIBS)
  set(Python3_USE_STATIC_LIBS FALSE)
endif()
find_package_auto(ENABLE_PYTHON_SCRIPTING Python3 3.3 COMPONENTS Development Interpreter)
find_package_auto(ENABLE_DOCS             Sphinx) # Should come after ENABLE_PYTHON_SCRIPTING
find_package_auto(ENABLE_LIBSPIRO         Libspiro)
find_package_auto(ENABLE_LIBUNINAMESLIST  Libuninameslist)
find_package_auto(ENABLE_LIBGIF           GIF)
find_package_auto(ENABLE_LIBJPEG          JPEG)
find_package_auto(ENABLE_LIBPNG           PNG)
find_package_auto(ENABLE_LIBREADLINE      Readline)
find_package_auto(ENABLE_LIBTIFF          TIFF)
find_package_auto(ENABLE_WOFF2            WOFF2)
find_package_auto(ENABLE_CODE_COVERAGE    Gcov)

add_subdirectory(inc)
add_subdirectory(Unicode)
add_subdirectory(gutils)
add_subdirectory(fontforge)
if(ENABLE_GUI)
  add_subdirectory(gdraw)
endif()
add_subdirectory(fontforgeexe)
if(ENABLE_PYTHON_EXTENSION)
  if(ENABLE_PYTHON_SCRIPTING_RESULT AND BUILD_SHARED_LIBS)
    set(ENABLE_PYTHON_EXTENSION_RESULT ON)
  elseif(NOT "${ENABLE_PYTHON_EXTENSION}" STREQUAL "AUTO")
    message(FATAL_ERROR "ENABLE_PYTHON_EXTENSION cannot be enabled if either ENABLE_PYTHON_SCRIPTING or BUILD_SHARED_LIBS is not")
  else()
    set(ENABLE_PYTHON_EXTENSION_RESULT OFF)
  endif()

  if(ENABLE_PYTHON_EXTENSION_RESULT)
    add_subdirectory(pyhook)
  endif()
endif()
add_subdirectory(contrib)
if(ENABLE_PYTHON_SCRIPTING_RESULT)
  add_subdirectory(pycontrib)
endif()
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()
add_subdirectory(desktop)
if(ENABLE_DOCS AND Sphinx_FOUND)
  add_subdirectory(doc)
endif()
add_subdirectory(po)
add_subdirectory(share)
if(APPLE)
  add_subdirectory(osx)
endif()

setup_cpack()
print_build_options()

=== contrib/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

if(ENABLE_MAINTAINER_TOOLS)
  add_subdirectory(cidmap)
endif()
if(ENABLE_FONTFORGE_EXTRAS)
  add_subdirectory(fonttools)
endif()

=== fontforgeexe/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

add_executable(fontforgeexe main.c)
set_target_properties(fontforgeexe PROPERTIES OUTPUT_NAME "fontforge")

if(ENABLE_GUI)
  target_sources(fontforgeexe PRIVATE
    alignment.c
    anchorsaway.c
    autowidth2dlg.c
    basedlg.c
    bdfinfo.c
    bitmapdlg.c
    bitmapview.c
    charinfo.c
    charview_private.h
    charview.c
    clipui.c
    combinations.c
    contextchain.c
    cursors.c
    cvaddpoints.c
    cvdebug.c
    cvdgloss.c
    cvexportdlg.c
    cvfreehand.c
    cvgetinfo.c
    cvgridfit.c
    cvhand.c
    cvhints.c
    cvimportdlg.c
    cvknife.c
    cvpalettes.c
    cvpointer.c
    cvruler.c
    cvruler.h
    cvshapes.c
    cvstroke.c
    cvtranstools.c
    deltaui.c
    displayfonts.c
    effectsui.c
    encodingui.c
    fontinfo.c
    fontview.c
    freetypeui.c
    fvfontsdlg.c
    fvmetricsdlg.c
    gotodlg.c
    groupsdlg.c
    histograms.c
    images.c
    justifydlg.c
    kernclass.c
    layer2layer.c
    lookupui.c
    macencui.c
    math.c
    metricsview.c
    mmdlg.c
    nonlineartransui.c
    openfontdlg.c
    prefs.c
    problems.c
    pythonui.c
    savefontdlg.c
    scriptingdlg.c
    scstylesui.c
    searchview.c
    sftextfield.c
    sftextfieldP.h
    sfundo.c
    sfundo.h
    showatt.c
    simplifydlg.c
    splashimage.c
    startui.c
    statemachine.c
    tilepath.c
    transform.c
    ttfinstrsui.c
    uiutil.c
    usermenu.c
    usermenu.h
    windowmenu.c
    wordlistparser.c
    wordlistparser.h
  )

  if(APPLE)
    target_sources(fontforgeexe PRIVATE macobjective.m)
    target_link_libraries(fontforgeexe
      PRIVATE
      "-framework Cocoa"
    )
  endif()

  if(ENABLE_FREETYPE_DEBUGGER)
    target_link_libraries(fontforgeexe PRIVATE Threads::Threads)
  endif()

  target_link_libraries(fontforgeexe PRIVATE gdraw)
else()
  target_sources(fontforgeexe PRIVATE startnoui.c)
endif()

if(ENABLE_PYTHON_SCRIPTING_RESULT)
  target_link_libraries(fontforgeexe PRIVATE Python3::Python)
endif()

target_link_libraries(fontforgeexe PRIVATE fontforge Iconv::Iconv MathLib::MathLib)
install(TARGETS fontforgeexe RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if(UNIX)
  install(CODE "
    foreach(_script fontimage.pe fontlint.pe sfddiff.pe)
      get_filename_component(_output \"\${_script}\" NAME_WE)
      file(READ \"${CMAKE_CURRENT_SOURCE_DIR}/\${_script}\" _input)
      file(WRITE \"${CMAKE_CURRENT_BINARY_DIR}/\${_output}\" \"#!\${CMAKE_INSTALL_PREFIX}/bin/fontforge -lang=ff\\n\${_input}\")
    endforeach()
  " COMPONENT nativescripts)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fontimage" "${CMAKE_CURRENT_BINARY_DIR}/fontlint" "${CMAKE_CURRENT_BINARY_DIR}/sfddiff"
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    COMPONENT nativescripts
  )
else()
  install(FILES fontimage.pe fontlint.pe sfddiff.pe DESTINATION ${CMAKE_INSTALL_DATADIR}/fontforge/nativescripts COMPONENT nativescripts)
endif()
install(FILES fontforge.1 sfddiff.1 fontlint.1 fontimage.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

add_subdirectory(pixmaps)

=== gdraw/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# not included
#  gdrawwacomdriver.c genkeysym.c growcol.c

add_library(gdraw STATIC
  choosericons.c
  colorP.h
  ctlvalues.c
  div_tables.c
  drawboxborder.c
  fontP.h
  gaskdlg.c
  gbuttons.c
  gchardlg.c
  gcolor.c
  gcontainer.c
  gdrawable.c
  gdrawbuildchars.c
  gdraw.c
  gdrawerror.c
  gdrawgimage.c
  gdrawP.h
  gdrawtxt.c
  gdrawtxtinit.c
  gfilechooser.c
  gfiledlg.c
  ggadgetP.h
  ggadgets.c
  ggdkcdraw.c
  ggdkdraw.c
  ggdkdrawlogger.c
  ggdkdrawP.h
  ggroupbox.c
  ghvbox.c
  gimageclut.c
  gimagecvt.c
  gimagexdraw.c
  gkeysym.c
  glist.c
  gmatrixedit.c
  gmenu.c
  gprogress.c
  gradio.c
  gresedit.c
  gresource.c
  gresourceimage.c
  gresourceP.h
  gsavefiledlg.c
  gscrollbar.c
  gspacer.c
  gtabset.c
  gtextfield.c
  gtextinfo.c
  gwidgetP.h
  gwidgets.c
  gxcdraw.c
  gxcdrawP.h
  gxdraw.c
  gxdrawP.h
  hotkeys.c
  xkeysyms_unicode.c
)

target_link_libraries(gdraw PRIVATE fontforge)

if(ENABLE_X11)
  target_link_libraries(gdraw PUBLIC
    X11::X11
    X11::Xi
    X11::Xkb
    Cairo::Cairo
    Pango::Pango
  )
else()
  if(APPLE)
    target_sources(gdraw PRIVATE ggdkcocoa.m)
  endif()
  target_link_libraries(gdraw PUBLIC GDK3::GDK3)
endif()

=== po/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# * Run the 'pofiles' command to generate the binary .mo files
# * Run the 'potfiles' ocmmand to generate the master .pot file
#   (which cotnains all translatable strings)
# * Run the 'fullpo' command to generate the .po files, merged
#   with the master .pot file and with context

# TODO: Probably should add a FindXGettext or something
add_custom_target(potfiles
  COMMAND xgettext
    --from-code=utf-8
    -k_ -kN_ -kS_ -kU_ -kNU_ -kP_:1,2
    --sort-by-file
    --add-comments=GT:
    "-o${CMAKE_CURRENT_BINARY_DIR}/FontForge.pot"
    ../fontforge/*.c
    ../fontforgeexe/*.c
    ../gdraw/*.c
    ../gutils/*.c
    ../inc/*.h
    ../desktop/org.fontforge.FontForge.appdata.xml.in
    ../desktop/org.fontforge.FontForge.desktop
  COMMAND patch "${CMAKE_CURRENT_BINARY_DIR}/FontForge.pot" "pottitle.patch"
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

file(STRINGS LINGUAS _langs)

foreach(_lang ${_langs})
  set(_input "${CMAKE_CURRENT_SOURCE_DIR}/${_lang}.po")
  set(_output "${CMAKE_CURRENT_BINARY_DIR}/${_lang}.mo")
  set(_full "${CMAKE_CURRENT_BINARY_DIR}/full/${_lang}.po")
  add_custom_command(OUTPUT "${_output}"
    COMMAND "${GETTEXT_MSGFMT_EXECUTABLE}" --check -o "${_output}" "${_input}"
    DEPENDS "${_input}"
    VERBATIM
  )
  add_custom_command(OUTPUT "${_full}"
    COMMAND "${CMAKE_COMMAND}" -E make_directory "${CMAKE_CURRENT_BINARY_DIR}/full"
    COMMAND "${GETTEXT_MSGMERGE_EXECUTABLE}" -N "${_input}" -F "${CMAKE_CURRENT_BINARY_DIR}/FontForge.pot" -o "${_full}"
    DEPENDS "${_input}" potfiles
    VERBATIM
  )
  install(FILES "${_output}" DESTINATION "${CMAKE_INSTALL_LOCALEDIR}/${_lang}/LC_MESSAGES" RENAME "FontForge.mo" COMPONENT pofiles)
  list(APPEND _outputs "${_output}")
  list(APPEND _fulls "${_full}")
endforeach()

add_custom_target(pofiles ALL DEPENDS ${_outputs})
add_custom_target(fullpo DEPENDS ${_fulls})

if(ENABLE_MAINTAINER_TOOLS)
  add_executable(toengb toengb.c)
endif()

=== pyhook/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

add_library(fontforge_pyhook MODULE fontforgepyhook.c)
add_library(psMat_pyhook MODULE psMatpyhook.c)

set_target_properties(fontforge_pyhook PROPERTIES OUTPUT_NAME "fontforge" PREFIX "")
set_target_properties(psMat_pyhook PROPERTIES OUTPUT_NAME "psMat" PREFIX "")

if(WIN32)
  set_target_properties(fontforge_pyhook PROPERTIES SUFFIX ".pyd")
  set_target_properties(psMat_pyhook PROPERTIES SUFFIX ".pyd")
endif()

target_link_libraries(fontforge_pyhook PRIVATE fontforge)
target_link_libraries(psMat_pyhook PRIVATE fontforge)

target_link_libraries(fontforge_pyhook PRIVATE Python3::Module)
target_link_libraries(psMat_pyhook PRIVATE Python3::Module)

# FindPython3 provides Python3_SITEARCH, but this is an absolute path
# So do it ourselves, getting the prefix-relative path instead
if(NOT DEFINED PYHOOK_INSTALL_DIR)
  execute_process(
    COMMAND "${Python3_EXECUTABLE}" -c "import distutils.sysconfig as sc; print(sc.get_python_lib(prefix='', plat_specific=True,standard_lib=False))"
    RESULT_VARIABLE _pyhook_install_dir_result
    OUTPUT_VARIABLE PYHOOK_INSTALL_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if(NOT PYHOOK_INSTALL_DIR OR _pyhook_install_dir_result)
    message(FATAL_ERROR "Could not determine the path to install pyhook binaries to, got '${PYHOOK_INSTALL_DIR}' with return value ${_pyhook_install_dir_result}")
  endif()
  set(PYHOOK_INSTALL_DIR "${PYHOOK_INSTALL_DIR}" CACHE STRING "Path to install pyhook to")
endif()

install(TARGETS fontforge_pyhook psMat_pyhook LIBRARY DESTINATION "${PYHOOK_INSTALL_DIR}")

=== tests/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# Note that you should invoke the `check` target instead of
# the `test` target so that test-specific prerequisites are checked.

include(TestUtils)

if(NOT ENABLE_NATIVE_SCRIPTING AND NOT ENABLE_PYTHON_SCRIPTING_RESULT)
  return()
endif()

add_executable(systestdriver systestdriver.c)
target_link_libraries(systestdriver PRIVATE GLIB::GLIB)
if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
  target_compile_options(systestdriver PRIVATE -Wall -pedantic)
endif()

# Downloaded files
add_download_target("NotoSans-Regular.ttc" "https://github.com/fontforge/debugfonts/raw/master/NotoSans-Regular.ttc")
add_download_target("MunhwaGothic-Bold" "https://github.com/fontforge/debugfonts/raw/master/MunhwaGothic-Bold")

add_custom_target(test_dependencies
  DEPENDS
  "${CMAKE_CURRENT_BINARY_DIR}/fonts/NotoSans-Regular.ttc"
  "${CMAKE_CURRENT_BINARY_DIR}/fonts/MunhwaGothic-Bold"
)

add_custom_target(check
  COMMAND "${CMAKE_CTEST_COMMAND}" "--output-on-failure" "--force-new-ctest-process"
  DEPENDS
    test_dependencies
    fontforgeexe
    systestdriver
  VERBATIM
  USES_TERMINAL
)

if(ENABLE_PYTHON_SCRIPTING_RESULT AND ENABLE_PYTHON_EXTENSION_RESULT)
  add_dependencies(check fontforge_pyhook psMat_pyhook)
endif()

if(ENABLE_NATIVE_SCRIPTING)
  add_ff_test(test001.pe "Caliban.sfd" "Zapfino-4.0d3.dfont" "Zapfino-4.1d6.dfont" "Generate a few font files")
  add_ff_test(test002.pe "HanSans-Bold.otf"                                        "OTF CID font check")
  add_ff_test(test003.pe "MunhwaGothic-Bold"                                       "Non-OTF CID font check")
  add_ff_test(test004.pe "mingliu.ttc"                                             "Chunk of memory check")
  add_ff_test(test005.pe "VKern.sfd"                                               "Kerning information checks")
  add_ff_test(test006.pe "mingliu.ttc" "GillSans.dfont" "ItalicHand.sfd" "ItalicHand.svg" "MunhwaGothic-Bold" "Caliban.otf" "Incorrect names and count checks")
  add_ff_test(test007.pe "FormalScript.sfd" "dvng10a-crash.sfd"                    "Contextual chaining tables don't crash")
  add_ff_test(test008.pe "n019003l.pfb"                                            "Contextual chaining tables don't crash")
  add_ff_test(test009.pe "Ambrosia.sfd"                                            "Read and generate Type3 fonts")
  add_ff_test(test010.pe "GillSans.dfont"                                          "Generate some error messages")
  add_ff_test(test101.pe                                                           "Check for unexpected")
  add_ff_test(test102.pe "AHBugs.sfd"                                              "Infinite loop test on 0 length spline")
  add_ff_test(test103.pe                                                           "Copy/Paste clipboard test for crash")
  add_ff_test(test104.pe "SplineOverlapBug1.sfd"                                   "Remove overlap test #1")
  add_ff_test(test105.pe                                                           "while loop check  loop 10x")
  add_ff_test(test106.pe "OmittedCharBugs.sfd"                                     "Simple 'Bad Kerning' check")
  add_ff_test(test107.pe "Ambrosia.sfd" "AmbrosiaBold.sfd" "AmbrosiaItalic.sfd"    "Generate a font family") # also calls 'helper107.pe'
  add_ff_test(test108.pe "ItalicHand.sfd"                                          "Make GPOS  GSUB  morx without crashing")
  add_ff_test(test109.pe "OverlapBugs.sfd" "feta20.pfb"                            "Remove overlap test #2")
  add_ff_test(test110.pe "SimplifyBugs.sfd"                                        "Test simplify")
  add_ff_test(test111.pe "cmbsy10.pfb"                                             "Test merge fonts")
  add_ff_test(test112.pe "CourierNew.ttf"                                          "Test quadratic conversion")
  add_ff_test(test113.pe "CourierNew.ttf"                                          "Count contour points properly")
  add_ff_test(test114.pe "CaslonMM.sfd"                                            "Generate  save and open a .pfa file")
  add_ff_test(test115.pe "n019003l.pfb"                                            "Replace with reference")
  add_ff_test(test116.pe "merged.cff"                                              "Merged")
  add_ff_test(test117.pe "ecrm1000.pfb" "ecrm1000.tfm"                             "Merge kern")
  add_ff_test(test118.pe "NimbusLGCUni-Regular.sfd"                                "Test Unicode encodings") # also uses helper118A.pe helper118B.pe
  add_ff_test(test119.pe "DejaVuSerif.sfd"                                         "The 'i' glyph test")
  add_ff_test(test120.pe "NumberPoints.sfd"                                        "Another deja-vu point number")
  add_ff_test(test121.pe "AddExtremumTest.sfd"                                     "Don't distort the curve (by much)")
  #add_ff_test(test122.pe "Hinting.sfd"                                            "Check AutoHint works and retains hints")
  add_ff_test(test123.pe "MinionPro-Regular.otf"                                   "Produce equivalent font in CFF check")
  add_ff_test(test124.pe                                                           "Check that detach glyph works #1")
  add_ff_test(test125.pe "MinionPro-Regular.fea"                                   "Check that detach glyph works #2")
  add_ff_test(test126.pe "DataURI.sfd"                                             "Try SVG and PT3")
  add_ff_test(test127.pe "Ambrosia.sfd"                                            "Test generation of TrueType instructions")
  #add_ff_test(svg2ttf.pe "")
  add_ff_test(test128.pe                                                           "Test StrSplit overrun")
  add_ff_test(test129.pe                                                           "Ligatures and Fractions Table Lookups")
  add_ff_test(test130.pe "NotoSans-Regular.ttc"                                    "TTC loading")
  add_ff_test(test131.pe                                                           "libnameslist checks")
  if(ENABLE_WOFF2_RESULT)
    add_ff_test(test132.pe "CantarellMin.woff2"                                    "WOFF2 round tripping")
  endif()
  add_ff_test(test133.pe "test133.fea"                                             "Allowed characters in glyph class names")
  add_ff_test(test134.pe "test134.fea"                                             "Short-hand contextual multiple substitution")
  add_ff_test(test135.pe "test135.fea"                                             "GDEF glyph classes")
  add_ff_test(test136.pe "test136.fea"                                             "Re-using mark filtering set")
  add_ff_test(test137.pe "Ambrosia.sfd"                                            "file:// protocol")
  add_ff_test(test138.pe                                                           "Array sanity checking")
  add_ff_test(test139.pe "StrokeTests.sfd"                                            "ExpandStroke parameters")
endif()

if(ENABLE_PYTHON_SCRIPTING_RESULT)
  add_py_test(test0001.py "Ambrosia.sfd" "FontForge .sfd file open check")
  add_py_test(test0002.py "AGL For New Fonts.txt" "Loading duplicate name list")
  add_py_test(test0003.py "BoxesAndBounds.sfd" "Bounding box sanity tests")
  add_py_test(test0004.py "OpenType script tag tests")
  add_py_test(test0101.py "NotoSans-Regular.ttc" "FontForge .ttc file open check")
  add_py_test(test1001.py "Caliban.sfd" "Generate several font files")
  add_py_test(test1001a.py "Zapfino-4.0d3.dfont" "Point count check")
  add_py_test(test1001b.py "Zapfino-4.1d6.dfont" "Odd morx test without crashing")
  add_py_test(test1001c.py "Make new font")
  add_py_test(test1002.py "nuvo-medium-woff-demo.woff" "WOFF major minor meta check")
  add_py_test(test1003.py "StrokeTests.sfd" "Various stroke tests")
  add_py_test(test1004.py "DirectionTest.sfd" "Clockwise direction test")
  add_py_test(test1005.py "AddExtremaTest2.sfd" "Generate duplicate fonts test")
  add_py_test(test1006.py "Math table test")
  add_py_test(test1007.py "ayn+meem.init.svg" "Check for splinestroke 0 len fail")
  add_py_test(test1008.py "OverlapBugs.sfd" "PythonAPI: font glyph iteration")
  add_py_test(test1009.py "Ligatures and Fractions Table Lookups")
  add_py_test(test1010.py "libnameslist checks")
  add_py_test(test1011.py "test1011.fea" "Feature file kerning with r2l lookup flag")
  add_py_test(test1012.py "test1012.otf" "GPOS kerning with r2l lookup flag")
  add_py_test(test1013.py "NotoSerifTibetan-Regular.ttf" "Read glyph names from unusual post table")
  add_py_test(test1014.py "PfEd layers round tripping")
  add_py_test(test1015.py "Caliban.sfd" "Reverse chaining tables")
  #add_py_test(findoverlapbugs.py "find overlap bug")
  add_py_test(test926.py "DejaVuSerif.sfd" "Validate WOFF output")
  if(ENABLE_WOFF2_RESULT)
    add_py_test(test927.py "CantarellMin.woff2" "WOFF2 round tripping")
  endif()
  add_py_test(test928.py "DejaVuSerif.sfd" "String Conversion")
  add_py_test(test929.py "NotoSans-Regular.ttc" "Open Subfonts")
  add_py_test(test930.py "Point, contour, and Layer fidelity")
  add_py_test(test931.py "Point type conversion tests")
  add_py_test(test932.py "Round-trip point selection tests")
endif()

=== contrib/cidmap/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

add_executable(mapcns1 src/mapcns1.c)
add_executable(mapgb1 src/mapgb1.c)
add_executable(mapjapan1 src/mapjapan1.c)
add_executable(mapjapan2 src/mapjapan2.c)
add_executable(mapkorean src/mapkorean.c)

target_link_libraries(mapcns1 PRIVATE fontforge)
target_link_libraries(mapgb1 PRIVATE fontforge)
target_link_libraries(mapjapan1 PRIVATE fontforge)
target_link_libraries(mapjapan2 PRIVATE fontforge)
target_link_libraries(mapkorean PRIVATE fontforge)

=== fontforgeexe/pixmaps/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# Set this for configuring the resources file
if(APPLE)
  set(GDRAW_GMENU_MACIONS "True")
else()
  set(GDRAW_GMENU_MACIONS "False")
endif()

add_subdirectory(${THEME})

=== fontforgeexe/pixmaps/2012/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

configure_file(resources-georgd.in resources)
install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/resources"
  DESTINATION ${CMAKE_INSTALL_DATADIR}/fontforge/pixmaps
  COMPONENT theme
)

install(FILES
  changeweight.png chooseraudio.png chooserback.png chooserbookmark.png choosercid.png
  choosercompressed.png chooserconfigtool.png choosercore.png chooserdir.png chooserforward.png
  chooserhomefolder.png chooserimage.png choosermac.png choosermacttf.png choosernobookmark.png
  chooserobject.png choosertar.png choosertextbdf.png choosertextc.png choosertextcss.png
  choosertextfontps.png choosertextfontsfd.png choosertexthtml.png choosertextjava.png
  choosertextmake.png choosertextplain.png choosertextps.png choosertextxml.png chooserttf.png
  chooserunknown.png chooserupdir.png chooservideo.png colorwheel.png editclearback.png editclear.png
  editcopyfg2bg.png editcopylayer2layer.png editcopylbearing.png editcopylookupdata.png editcopy.png
  editcopyrbearing.png editcopyref.png editcopyvwidth.png editcopywidth.png editcut.png editfind.png
  editjoin.png editmerge.png editpasteafter.png editpasteinto.png editpaste.png editredo.png
  editrmundoes.png editrplref.png editsameas.png editselect.png editundo.png editunlink.png
  elementaddextrema.png elementalign.png elementanticlock.png elementautotrace.png elementbdfinfo.png
  elementbitmapsavail.png elementbuildaccent.png elementbuildcomposite.png elementclockwise.png
  elementcomparefonts.png elementcomparelayers.png elementcorrectdir.png elementexpandstroke.png
  elementfindprobs.png elementfontinfo.png elementgetinfo.png elementglyphinfo.png
  elementhbaselines.png elementinterpolatefonts.png elementmathinfo.png elementmergefonts.png
  elementorder.png elementotherinfo.png elementregenbitmaps.png elementremovebitmaps.png
  elementrenameglyph.png elementround.png elementshowdep.png elementsimplify.png elementstyles.png
  elementtilepath.png elementtilepattern.png elementtransform.png elementvalidate.png
  elementvbaselines.png exclude.png extendcondense.png fflogo13.png fflogo.png ffsplash1.png
  ffsplash2.png ffsplash3.png fileclose.png filedisplay.png fileexecute.png fileexport.png
  filegeneratefamily.png filegenerate.png fileimport.png filemergefeature.png filenew.png fileopen.png
  fileprefs.png fileprint.png filequit.png filerecent.png filerevertbackup.png filerevertglyph.png
  filerevert.png filesaveall.png filesaveas.png filesave.png findinter.png fliphor.png flipvert.png
  helpabout.png helphelp.png helpindex.png hintsadddstem.png hintsaddhstem.png hintsaddvstem.png
  hintsautohint.png hintscleardstems.png hintsclearhstems.png hintsclearvstems.png
  hintsdontautohint.png hintsreviewhints.png inline.png intersection.png menuempty.png
  metricscenter.png metricssetlbearing.png metricssetrbearing.png metricssetvwidth.png
  metricssetwidth.png oblique.png outline.png overlapexclude.png overlapfindinter.png
  overlapintersection.png overlaprm.png palette3drotate.png palettecorner.png palettecurve.png
  paletteelipse.png paletteflip.png palettefreehand.png palettehand.png palettehvcurve.png
  paletteknife.png paletteline.png palettemagnify.png palettepencil.png palettepen.png
  paletteperspective.png palettepointer.png palettepoly.png paletterect.png paletterotate.png
  paletteruler.png palettescale.png paletteshift.png paletteskew.png palettesmall3drotate.png
  palettesmallcorner.png palettesmallcurve.png palettesmallelipse.png palettesmallflip.png
  palettesmallhand.png palettesmallhvcurve.png palettesmallknife.png palettesmallmag.png
  palettesmallpencil.png palettesmallpen.png palettesmallperspective.png palettesmallpointer.png
  palettesmallpoly.png palettesmallrect.png palettesmallrotate.png palettesmallruler.png
  palettesmallscale.png palettesmallskew.png palettesmallspirocorner.png palettesmallspirocurve.png
  palettesmallspirog2curve.png palettesmallspiroleft.png palettesmallspiroright.png
  palettesmallstar.png palettesmalltangent.png palettespirocorner.png palettespirocurve.png
  palettespirodisabled.png palettespirodown.png palettespirog2curve.png palettespiroleft.png
  palettespiroright.png palettespiroup.png palettestar.png palettetangent.png pointsaddanchor.png
  pointscorner.png pointscurve.png pointsG2curve.png pointshvcurve.png pointsmakearc.png
  pointsmakeline.png pointsnamecontour.png pointsnamepoint.png pointsspironext.png pointsspiroprev.png
  pointstangent.png ptinfocorner.png ptinfocurve.png ptinfohvcurve.png ptinfotangent.png python.png
  rmoverlap.png rotate180.png rotateccw.png rotatecw.png selectblue.png selectcyan.png
  selectdefault.png selectgreen.png selectmagenta.png selectred.png selectwhite.png selectyellow.png
  shadow.png skew.png styleschangeweight.png styleschangexheight.png stylesextendcondense.png
  stylesinline.png stylesitalic.png stylesoblique.png stylesoutline.png stylesshadow.png
  stylessmallcaps.png stylessubsuper.png styleswireframe.png tools3drotate.png toolselipse.png
  toolsflip.png toolsfreehand.png toolsknife.png toolsmagnify.png toolspen.png toolsperspective.png
  toolspointer.png toolspolygon.png toolsrect.png toolsrotate.png toolsruler.png toolsscale.png
  toolsscroll.png toolsskew.png toolsspiro.png toolsstar.png transformfliphor.png
  transformflipvert.png transformrotate180.png transformrotateccw.png transformrotatecw.png
  transformskew.png ttdebugcontinue.png ttdebugexit.png ttdebugmenudelta.png ttdebugstepinto.png
  ttdebugstepout.png ttdebugstepover.png ttdebugstopped.png ttdebugstop.png ttdebugwatchpnt.png
  viewbiggersize.png viewfindinfont.png viewfit.png viewformer.png viewgoto.png viewinsertafter.png
  viewinsertbefore.png viewlayers.png viewnextdef.png viewnext.png viewpalettes.png viewprevdef.png
  viewprev.png viewreplace.png viewsmallersize.png viewzoomin.png viewzoomout.png wireframe.png

  charviewicon.xbm fontview2.xbm logo.xbm

  ../tango/Cantarell-BoldOblique.ttf ../tango/Cantarell-Bold.ttf
  ../tango/Cantarell-Oblique.ttf ../tango/Cantarell-Regular.ttf
  ../tango/Inconsolata-Bold.ttf ../tango/Inconsolata-Regular.ttf

  "${CMAKE_CURRENT_BINARY_DIR}/resources"

  DESTINATION ${CMAKE_INSTALL_DATADIR}/fontforge/pixmaps
  COMPONENT theme
)

=== debian/changelog ===
fontforge (1:20201107~dfsg-4build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:13:50 +0000

fontforge (1:20201107~dfsg-4) unstable; urgency=medium

  * Rename extended to extendeddbl to avoid FTBFS on Hurd.
    gnumach-dev 1.8+git20201129 added to /usr/include/i386-gnu/mach/i386/fp_reg.h
    a new "extended" field which happens to collide with the custom-defined
    "extended" type in FontForge, leading to FTBFS on hurd-i386.
    See 0005-hurd-rename-extended-to-avoid-conflict-with-gnumach-dev.patch
  * Rename 0004-hurd-compatibility.patch to 0004-hurd-PATH_MAX-and-MAXPATHLEN.patch

 -- Anthony Fok <foka@debian.org>  Fri, 15 Jan 2021 08:55:46 -0700

fontforge (1:20201107~dfsg-3) unstable; urgency=medium

  [ Helmut Grohne ]
  * Reduce Build-Depends via Build-Depends-Indep. (Closes: #977954)

  [ Anthony Fok ]
  * debian/control:
    - Remove uthash-dev and libxt-dev from build-dependency as they are not
      used any more by the build.  Thanks to Helmut Grohne for the suggestion.
    - Specify that fontforge "Provides: fontforge-nox" (Closes: #976736)
    - debian/control: Remove "XS-Python-Version: all" which was for Python 2
    - Bump Standards-Version to 4.5.1 (no change)
  * Define PATH_MAX and MAXPATHLEN to fix FTBFS on GNU/Hurd.
    See debian/patches/0004-hurd-compatibility.patch (Closes: #877795)
  * 2003_avoid_privacy_breach.patch: Fix "more than 2 sections in header"
    error as reported by "cme fix dpkg"
  * debian/fontforge*.install: Sort lines in alphabetical order, by
    "cme fix dpkg"

 -- Anthony Fok <foka@debian.org>  Fri, 15 Jan 2021 00:41:32 -0700

fontforge (1:20201107~dfsg-2) unstable; urgency=medium

  * debian/libfontforge4.install: Fix incorrect path.  For example, on i386,
    /usr/bin/${DEB_HOST_GNU_TYPE} resolves to /usr/bin/i686-linux-gnu which
    does not exist on Debian, whereas /usr/bin/${DEB_HOST_MULTIARCH} correctly
    resolves to /usr/bin/i386-linux-gnu that we need (Closes: #975460)
  * debian/rules: Fix binary-indep build by adding override_dh_missing-indep
  * Add debian/python3-fontforge.lintian-overrides
    as Lintian fails to find libfontforge.so.4 (from libfontforge4 package)
    and thus raises false library-not-linked-against-libc errors
  * Update debian/libfontforge4.lintian-overrides
    to point the new location of libfontforge.so.4
  * Remove obsolete debian/libfontforge-dev.links
  * Add debian/patches/2004-fix-privacy-breach-logo.patch
    to fix Lintian privacy-breach-logo errors in the Japanese translation
    of old FontForge documentation
  * Add 0003-use-local-libjs-mathjax.patch and fontforge-doc.links
    to fix Lintian privacy-breach-generic warnings
  * Fix Lintian link-to-shared-library-in-wrong-package warning by removing
    unused usr/lib/*/libfontforge.so symlink from libfontforge4 package
  * Mark libfontforge4 and python3-fontforge "Multi-Arch: same"
    as suggested by Multiarch hinter

 -- Anthony Fok <foka@debian.org>  Tue, 24 Nov 2020 18:21:25 -0700

fontforge (1:20201107~dfsg-1) unstable; urgency=medium

  [ Jonas Smedegaard ]
  * New upstream version 20200314~dfsg (Closes: #963194)
    + Fixes two security vulnerabilities:
      - CVE-2020-5395 (use-after-free in SFD_GetFontMetaData in sfd.c)
      - CVE-2020-5496 (heap-based buffer overflow in the Type2NotDefSplines()
        function in splinesave.c)
      that were found in FontForge 20190801 (Closes: #948231)
  * copyright: update overage
  * use buildsystem cmake+ninja (not autotools);
    build-depend on cmake ninja-build
    (not libltdl-dev autoconf-archive)
  * stop build-depend on chrpath
    (unused since 1:20160404~dfsg-1)
  * update install paths
    (upstream installs appdata in correct path now)
  * drop patches 0003 0004 2002 3000:
    obsoleted by new upstream release
  * update (and reduce) patch 2003
  * add patches cherry-picked upstream to fix a range of issues
    Fixes "FTBFS on 64-bit big endian: test failures" (Closes: #961841)
  * bump library API major version to 4
  * drop libgdraw package:
    upstream no longer provides that as shared library
  * stop ship python simple/* scripts:
    No longer installed upstream
  * Temporarily omit installing scripts for fontforge-extras,
    seemingly not built upstream
  * build sphinx documentation;
    build-depend on dh-sequence-sphinxdoc
  * stop ship extra libraries libgunicode.so libgutils.so:
    upstream no longer provides those as shared library

  [ Hideki Yamane ]
  * specify dh 13
  * fix to add ${DEB_HOST_MULTIARCH} for libfontforge.so path
  * Add python3-sphinx for document build for GUI build
  * Add more build options MAINTAINER_TOOLS and WRITE_PFM

  [ Anthony Fok ]
  * New upstream version 20201107~dfsg (FontForge 20th Anniversary Edition)
    + Display issues on Wayland are now fixed (Closes: #961640)
  * Remove cherry-picked upstream patches as they are included in 20201107
  * debian/rules: Change override_dh_* to execute_before_dh_* where possible
  * Remove libfontforge-dev package.  Upstream has decided to stop installing
    development files since 20200314 due to unstable stable API or ABI etc.
    No Debian package has ever build-depended on libfontforge-dev either.
  * Install README.md instead of the now nonexistent README
  * debian/control: Add ${sphinxdoc:Depends} and ${sphinxdoc:Built-Using}
    for python3-fontforge
  * debian/rules: Remove manual call to sphinx-build
    as it is already called by upstream doc/CMakeLists.txt
  * Restore files that were installed to fontforge-extras and python3-fontforge
    prior to the FontForge 2020 March Release by patching CMakeLists.txt
    files, see debian/patches/0001-add-extra-cmake-install-rules.patch
  * Add debian/libfontforge4.install as we no longer uses d-shlibs
  * Add and fix other debian/*.install, debian/*.manpages and debian/rules
    so that all files are installed properly


=== debian/control ===
Source: fontforge
Section: fonts
Priority: optional
Maintainer: Debian Fonts Task Force <debian-fonts@lists.debian.org>
Uploaders:
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
 Davide Viti <zinosat@tiscali.it>,
 Hideki Yamane <henrich@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
 Rogério Brito <rbrito@ime.usp.br>,
 Vasudev Kamath <vasudev@copyninja.info>,
 Anthony Fok <foka@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 shared-mime-info,
 libreadline-dev,
 libcairo2-dev,
 libfreetype-dev,
 libgif-dev,
 libjpeg-dev,
 libpango1.0-dev,
 libpng-dev,
 libspiro-dev,
 libtiff5-dev,
 libuninameslist-dev,
 libxml2-dev,
 libglib2.0-dev,
 ninja-build,
 python3,
 python3-dev,
 libwoff-dev,
 libgtk-3-dev,
 pkg-kde-tools
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 desktop-file-utils,
 potrace,
 python3-sphinx,
Standards-Version: 4.5.1
Homepage: https://fontforge.github.io/en-US/
Vcs-Git: https://salsa.debian.org/fonts-team/fontforge.git
Vcs-Browser: https://salsa.debian.org/fonts-team/fontforge
Rules-Requires-Root: no

Package: fontforge
Architecture: any
Multi-Arch: foreign
Depends:
 fontforge-common (= ${source:Version}),
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 fontforge-nox
Provides:
 fontforge-nox
Suggests:
 fontforge-doc,
 fontforge-extras,
 potrace,
 python3-fontforge,
Description: font editor
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package also provides these programs and utilities:
  fontimage - produce a font thumbnail image;
  fontlint  - checks the font for certain common errors;
  sfddiff   - compare two font files.

Package: fontforge-nox
Architecture: any
Multi-Arch: foreign
Depends:
 fontforge-common (= ${source:Version}),
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 fontforge
Description: font editor - non-X version
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package also provides these programs and utilities:
  fontimage - produce a font thumbnail image;
  fontlint  - checks the font for certain common errors;
  sfddiff   - compare two font files.
 .
 This package contains a version of FontForge compiled with support for
 scripting but no GUI, and not require the graphics library.

Package: fontforge-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Breaks:
 fontforge (<< 1:20160404~dfsg-3),
 fontforge-nox (<< 1:20160404~dfsg-3)
Recommends:
 fonts-cantarell,
 fonts-inconsolata
Description: font editor (common files)
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package contains common arch-independent files.

Package: libfontforge4
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Breaks:
 libfontforge2,
 libfontforge3,
 libgdraw5,
 libgdraw6,
Replaces:
 libfontforge2,
 libfontforge3,
 libgdraw5,
 libgdraw6,
Description: font editor - runtime library
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package contains the runtime library.

Package: python3-fontforge
Architecture: any
Multi-Arch: same
Depends:
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: 
 fontforge-nox | fontforge,
Breaks:
 python-fontforge
Replaces:
 python-fontforge
Section: python
Description: font editor - Python bindings
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package provides the Python modules (the libraries fontforge and
 psMat) to access a FontForge program for font manipulations.

Package: fontforge-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for fontforge
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package contains the documentation for fontforge.

Package: fontforge-extras
Architecture: any
Multi-Arch: foreign
Depends:
 fontforge-common (= ${source:Version}),
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: font editor - extra programs
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package also provides these programs and utilities:
  acorn2sfd
  dewoff
  woff
  findtable
  pcl2ttf
  pfadecrypt
  rmligamarks
  showttf
  stripttc
  ttf2eps
